Core - Bug # 52338

Task # 49162 (Resolved): Rewrite install tool

Status: Resolved Priority: Must have
Author: Ernesto Baschny Category: Install Tool
Created: 2013-09-27 Assigned To:

Updated: 2013-10-01 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity:

Is Regression: No

Sprint Focus:

Subject: Silent configuration generates endless redirect loop

Description

If | have some setting in my AdditionalConfiguration like:

$GLOBALS[TYPO3_CONF_VARST[GFXT[im_v5effects] = '1";

this will be always overwride whatever | have in my LocalConfiguration. Now the Install Tool has a "Auto-Configuration" which will try
to set this setting to "-1" (in LocalConfiguration). And after doing that, it will redirect to itself. But then the AdditionalConfiguration will

override this again and the game restarts.

Result is an endless loop.

This has to be detected somehow, because the current behavior is very touchy and you end up in an endless loop very easily.

Related issues:

related to Core - Task # 52414: ext:install Break possible redirect loop

Resolved

Associated revisions

Revision 263060d4 - 2013-10-01 16:53 - Anja Leichsenring

[BUGFIX] Base silent updates on LocalConfiguration values only

During silent updates the only file that can be influenced is
LocalConfiguration.php. If values are available in
AdditionalConfiguration.php, those take precedence, but can not be
overridden by the updater. This can lead to endless loops, because

preconditions are never met.

So silent update relies now only on values in LocalConfiguration.
For values in AdditionalConfiguration.php the user must take full

responsibility.

Change-Id: 15b450f0cf09f09bd3bb35a519b5b8d6b33e650ac
Resolves: #52338

Releases: 6.2

Reviewed-on: https://review.typo3.org/24140

Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn
Reviewed-by: Markus Klein
Reviewed-by: Ernesto Baschny
Tested-by: Ernesto Baschny

Revision ac3a58b8 - 2013-10-06 21:19 - Christian Kuhn

[TASK] ext:install Break possible redirect loop

The install tool initiates redirects if configuration values were
changed. This is especially done within the "silent upgrade" class.
If something goes wrong there, the system may end up in a redirect
loop and does not show useful debug information.

The patch introduces a simple redirect loop detection and breaks
after ten redirects. This should be enough for the "silent upgrade"

and should be lower than the usual browser based loop detection.

Change-Id: 131164595dc1ada17012525268b57c03499dd2ddf
Resolves: #52414

Related: #52338

Relases: 6.2

Reviewed-on: https://review.typo3.org/24191

Reviewed-by: Anja Leichsenring
Tested-by: Anja Leichsenring
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

History

#1 - 2013-09-27 17:47 - Ernesto Baschny

In this case, the SilentConfigurationUpgradeService::setimageMagickDetailSettings is the one that calls for an redirect, because it always end up with

a $changedValues.

#2 - 2013-09-28 12:10 - Christian Kuhn

This probably happens for more values.

Solution is to not access $GLOBALS['TYPO3_CONF_VARS'], but to work with ConfigurationManager getLocalConfigurationValueByPath() and

getConfigurationValueByPath()

#3 - 2013-09-29 20:36 - Christian Kuhn

- Parent task set to #49162

#4 - 2013-09-29 23:10 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24140
#5 - 2013-10-01 01:13 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24140

#6 - 2013-10-01 01:46 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24140

#7 - 2013-10-01 17:30 - Anja Leichsenring
- Status changed from Under Review to Resolved

Applied in changeset commit:263060d44d779abc54d8dbe00f43a3c1af287061.
